addHook("SpinSpecial", function(player)
	if (player.mo.skin == "sonic")
	    and (P_IsObjectOnGround(player.mo))
		and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.speed > 6*FRACUNIT)
		and not (player.speed > 9*FRACUNIT)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.state == S_PLAY_SPINDASH)
	and player.mo.skin == "sonic"
	and not (player.cmd.buttons & BT_SPIN)
	and not (player.pflags & PF_SPINNING)
		player.charging = false
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		P_Thrust(player.mo, player.mo.angle, 55*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
	end
end)


addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
	and player.mo.skin == "sonic"
	and (player.cmd.buttons & BT_SPIN)
	and player.speed > 9*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	    player.mo.state = S_PLAY_ROLL
	    S_StartSound(player.mo, sfx_spin)
	end
end)


addHook("SpinSpecial", function(player)
	if (player.mo.skin == "tails")
	    and (P_IsObjectOnGround(player.mo))
		and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.speed > 6*FRACUNIT)
		and not (player.speed > 9*FRACUNIT)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.state == S_PLAY_SPINDASH)
	and player.mo.skin == "tails"
	and not (player.cmd.buttons & BT_SPIN)
	and not (player.pflags & PF_SPINNING)
		player.charging = false
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		P_Thrust(player.mo, player.mo.angle, 55*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
	end
end)


addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
	and player.mo.skin == "tails"
	and (player.cmd.buttons & BT_SPIN)
	and player.speed > 9*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	    player.mo.state = S_PLAY_ROLL
	    S_StartSound(player.mo, sfx_spin)
	end
end)


addHook("SpinSpecial", function(player)
	if (player.mo.skin == "knuckles")
	    and (P_IsObjectOnGround(player.mo))
		and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.speed > 6*FRACUNIT)
		and not (player.speed > 9*FRACUNIT)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.state == S_PLAY_SPINDASH)
	and (player.mo.skin == "knuckles")
	and not (player.cmd.buttons & BT_SPIN)
	and not (player.pflags & PF_SPINNING)
		player.charging = false
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		P_Thrust(player.mo, player.mo.angle, 55*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
	end
end)


addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
	and player.mo.skin == "knuckles"
	and (player.cmd.buttons & BT_SPIN)
	and player.speed > 9*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	    player.mo.state = S_PLAY_ROLL
	    S_StartSound(player.mo, sfx_spin)
	end
end)


addHook("SpinSpecial", function(player)
	if (player.mo.skin == "metalsonic")
	    and (P_IsObjectOnGround(player.mo))
		and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.speed > 6*FRACUNIT)
		and not (player.speed > 9*FRACUNIT)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.state == S_PLAY_SPINDASH)
	and (player.mo.skin == "metalsonic")
	and not (player.cmd.buttons & BT_SPIN)
	and not (player.pflags & PF_SPINNING)
		player.charging = false
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		P_Thrust(player.mo, player.mo.angle, 55*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
	end
end)


addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
	and player.mo.skin == "metalsonic"
	and (player.cmd.buttons & BT_SPIN)
	and player.speed > 8*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	    player.mo.state = S_PLAY_ROLL
	    S_StartSound(player.mo, sfx_spin)
	end
end)


-- Others


addHook("PlayerThink", function(player)
	if (player.charging)
		player.mo.momz = 0*FRACUNIT
        player.mo.momy = 0*FRACUNIT
		player.mo.momx = 0*FRACUNIT
	end	
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "sonic")
    and (player.mo.state == S_PLAY_SPINDASH)
        return true
    end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "tails")
    and (player.mo.state == S_PLAY_SPINDASH)
        return true
    end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "knuckles")
    and (player.mo.state == S_PLAY_SPINDASH)
        return true
    end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "metalsonic")
    and (player.mo.state == S_PLAY_SPINDASH)
        return true
    end
end)